package RoLogger;

# 炶Plugin
# RoLogger.pm ver:1.02
# 

use 5.006;
use strict;
use warnings;
use Socket;

require Exporter;

our @ISA = qw(Exporter);

our %EXPORT_TAGS = ( 'all' => [ qw(
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
);
use vars qw($revision $VERSION);

$revision = '$Id: RoLogger.pm,v 1.02 2004/07/09 21:30:00 lstein Exp $';
$VERSION='1.02';

our $DefaultClass = 'RoLogger';

our %servers = (
    Chaos => 'Chaos',
    Loki => 'Loki',
    Iris => 'Iris',
    Fenrir => 'Fenrir',
    Sara => 'Sara',
    Lydia => 'Lydia',
    Baldur => 'Baldur',
    Odin => 'Odin',
    Thor => 'Thor',
    Freya => 'Freya',
    Bijou => 'Bijou',
    Idun => 'Idun',
    Heimdal => 'Heimdal',
    Eir => 'Eir',
    Tyr => 'Tyr',
    Lisa => 'Lisa',
    Ses => 'Ses',
    Tiamet => 'Tiamet'
);
# RoLogger1.25ȑOgĂꍇ͉L̂悤ɏ܂i#͏
#    Idun => 'Svr[211.13.232.35]',
#    Heimdal => 'Svr[211.13.232.67]',
#    Eir => 'Svr[211.13.232.99]',
#    Tyr => 'Svr[211.13.232.131]',
#    Lisa => 'Svr[211.13.232.163]',
#    Ses => 'Svr[211.13.232.195]',
#    Tiamet => 'Svr[211.13.232.227]'
#

our %clss = (
    GM_ => 'GM',
    WIS => 'WIS',
    GLD => 'GLD',
    PT_ => 'PT',
    Msg => 'OPN',
    Say => 'MY'
);

sub new {
    my ($class) = @_;
    shift if ($class && $class eq $DefaultClass);
    my $self = {
        class => \%clss
    };
    bless $self,$DefaultClass;
}

# &dayfile(YYYY,MM,DD,dir,chara,server)
# t@CʒuԂ
sub dayfile {
    my ($pkg, $year, $month, $day, $dir, $chara, $server) = arg_check(@_);
    
    my $path = sprintf("$dir/ChatSave_$servers{$server}_%d_%02d_%02d.txt",$year,$month,$day);
    return wantarray ? ($path, $chara) : $path;
}

# linesplit(line)
# ÖsAʁAԁAf[^ɐ؂蕪
sub linesplit {
    my ($pkg, $line) = arg_check(@_);
    my ($class);
    if ($line) {
        $line =~ /^(\d+\/\d+\/\d+),(\d+:\d+:\d+), (\w+?),\d+,(.+)/;
        if ($3) {
            $class = $clss{$3};
        } else {
            $class = '___';
        }
        return ($class, $2, $4);
    } else {
        return undef;
    }
}

# sys_decompose(dat)
# VXeO̔F
sub sys_decompose {
    my ($pkg, $dat) = arg_check(@_);
    return 0;
}

# wis_decompose(dat)
# wis̕
sub wis_decompose {
    my ($pkg, $dat) = arg_check(@_);
    $dat =~ /^(\(.+?\))\s(.+)/;
    return ($1, $2);
}

# opn_decompose(dat)
# ʏb̕
sub opn_decompose {
    my ($pkg, $dat) = arg_check(@_);
    $dat =~ /(.+?)\s:\s(.+)/;
    return ($1, $2);
}

sub arg_check {
    return @_ if defined($_[0]) && (!ref($_[0])) &&($_[0] eq $DefaultClass);
    our ($cls);
    unless (defined($_[0]) && (ref($_[0]) eq $DefaultClass || UNIVERSAL::isa($_[0],$DefaultClass))) {
        $cls = $DefaultClass->new() unless defined($cls);
        unshift(@_, $cls);
    }
    return wantarray ? @_ : $cls;
}

1;
